"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class CurationHistoryEntry(ProtocolElement):
    """
    A curation history entry, stores previous and new curation state, the
    date of the change and the author.
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "curation",
        "date",
        "userId",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_8 import cva as cva_1_5_3

        return {
            "curation": cva_1_5_3.Curation,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_8 import cva as cva_1_5_3

        return {
            "org.gel.models.cva.avro.Curation": cva_1_5_3.Curation,
            "org.gel.models.cva.avro.CurationHistoryEntry": cva_1_5_3.CurationHistoryEntry,
        }

    __slots__ = [
        "curation",
        "date",
        "userId",
    ]

    def __init__(
        self,
        curation,
        date,
        userId,
        validate=None,
        **kwargs
    ):
        """Initialise the cva_1_5_3.CurationHistoryEntry model.

        :param curation:
            The current curation at date
        :type curation: Curation
        :param date:
            Date in format yyyyMMddhhmm
        :type date: str
        :param userId:
            The author of the curation event
        :type userId: str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.5.3"
